# NOTE: Derived from blib/lib/PerlBean/Attribute/Factory.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package PerlBean::Attribute::Factory;

#line 228 "blib/lib/PerlBean/Attribute/Factory.pm (autosplit into blib/lib/auto/PerlBean/Attribute/Factory/create_attribute.al)"
sub create_attribute {
    my $self = shift;
    my $opt = shift || {};

    # Switch attribute type
    if ( ! defined($opt->{type} ) || $opt->{type} eq 'SINGLE') {
        require PerlBean::Attribute::Single;
        return( PerlBean::Attribute::Single->new($opt) );
    }
    elsif ( $opt->{type} eq 'BOOLEAN' ) {
        require PerlBean::Attribute::Boolean;
        return( PerlBean::Attribute::Boolean->new($opt) );
    }
    elsif ( $opt->{type} eq 'MULTI' ) {
        if ( $opt->{unique} ) {
            if ( $opt->{ordered} ) {
                require PerlBean::Attribute::Multi::Unique::Ordered;
                return( PerlBean::Attribute::Multi::Unique::Ordered->new($opt) );
            }
            elsif ( $opt->{associative} ) {
                if ( $opt->{method_key} ) {
                    require PerlBean::Attribute::Multi::Unique::Associative::MethodKey;
                    return( PerlBean::Attribute::Multi::Unique::Associative::MethodKey->new($opt) );
                }
                else {
                    require PerlBean::Attribute::Multi::Unique::Associative;
                    return( PerlBean::Attribute::Multi::Unique::Associative->new($opt) );
                }
            }
            else {
                require PerlBean::Attribute::Multi::Unique;
                return( PerlBean::Attribute::Multi::Unique->new($opt) );
            }
        }
        else {
            require PerlBean::Attribute::Multi::Ordered;
            return( PerlBean::Attribute::Multi::Ordered->new($opt) );
        }
    }
    else {
        throw Error::Simple("ERROR: PerlBean::Attribute::Factory::attribute, option 'type' must be one of 'BOOLEAN', 'SINGLE' or 'MULTI' and NOT '$opt->{type}'.");
    }
}

1;
# end of PerlBean::Attribute::Factory::create_attribute
